extern crate clap;
extern crate hercules_ir;
extern crate postcard;

use std::fs::File;
use std::io::prelude::*;

use clap::Parser;

#[derive(Parser, Debug)]
#[command(author, version, about, long_about = None)]
struct Args {
    hbin_file: String,
}

fn main() {
    let args = Args::parse();
    if !args.hbin_file.ends_with(".hbin") {
        eprintln!("WARNING: Running hercules_hbin_dump on a file without a .hbin extension - interpreting as a Hercules binary file.");
    }

    let mut f = File::open(args.hbin_file).unwrap();
    let mut buffer = vec![];
    f.read_to_end(&mut buffer).unwrap();
    let (manifest, _): (hercules_ir::ModuleManifest, Vec<u8>) =
        postcard::from_bytes(&buffer).unwrap();
    println!("{:#?}", manifest);
}
